(defvar icicle-universal-argument-map
  (let ((map (make-sparse-keymap))
        (universal-argument-minus
         ;; For backward compatibility, minus with no modifiers is an ordinary
         ;; command if digits have already been entered.
         `(menu-item "" negative-argument
                     :filter ,(lambda (cmd)
                                (if (integerp prefix-arg) nil cmd)))))
    (define-key map [switch-frame]
      (lambda (e) (interactive "e")
        (handle-switch-frame e) (icicle-universal-argument--mode)))
    (define-key map [?\C-u] 'icicle-universal-argument-more)
    (define-key map [?-] universal-argument-minus)
    (define-key map [?0] 'icicle-digit-argument)
    (define-key map [?1] 'icicle-digit-argument)
    (define-key map [?2] 'icicle-digit-argument)
    (define-key map [?3] 'icicle-digit-argument)
    (define-key map [?4] 'icicle-digit-argument)
    (define-key map [?5] 'icicle-digit-argument)
    (define-key map [?6] 'icicle-digit-argument)
    (define-key map [?7] 'icicle-digit-argument)
    (define-key map [?8] 'icicle-digit-argument)
    (define-key map [?9] 'icicle-digit-argument)
    (define-key map [kp-0] 'icicle-digit-argument)
    (define-key map [kp-1] 'icicle-digit-argument)
    (define-key map [kp-2] 'icicle-digit-argument)
    (define-key map [kp-3] 'icicle-digit-argument)
    (define-key map [kp-4] 'icicle-digit-argument)
    (define-key map [kp-5] 'icicle-digit-argument)
    (define-key map [kp-6] 'icicle-digit-argument)
    (define-key map [kp-7] 'icicle-digit-argument)
    (define-key map [kp-8] 'icicle-digit-argument)
    (define-key map [kp-9] 'icicle-digit-argument)
    (define-key map [kp-subtract] universal-argument-minus)
    map)
  "...")

(defun icicle-universal-argument--mode ()
  (prefix-command-update)
  (set-transient-map icicle-universal-argument-map nil))

(defun icicle-universal-argument ()
  (interactive)
  (prefix-command-preserve-state)
  (setq prefix-arg (list 4))
  (icicle-msg-maybe-in-minibuffer "prefix %S" prefix-arg)
  (icicle-universal-argument--mode))

(defun icicle-digit-argument (arg)
  (interactive "P")
  (digit-argument)
  (icicle-msg-maybe-in-minibuffer "prefix %S" prefix-arg))

(defun icicle-negative-argument (arg)
  (interactive "P")
  (negative-argument arg)
  (icicle-msg-maybe-in-minibuffer "prefix %S" prefix-arg))

(defun icicle-universal-argument-more (arg)
  (interactive "P")
  (universal-argument-more arg)
  (icicle-msg-maybe-in-minibuffer "prefix %S" prefix-arg))

(defun icicle-universal-argument-minus (arg)
  (interactive "P")
  (universal-argument-minus arg)
  (icicle-msg-maybe-in-minibuffer "prefix %S" prefix-arg))

(defun icicle-msg-maybe-in-minibuffer (format-string &rest args)
  (apply #'message format-string args)
  (sit-for 1))

(define-key minibuffer-local-completion-map [remap universal-argument]
  'icicle-universal-argument)
(define-key minibuffer-local-completion-map [remap negative-argument]
  'icicle-negative-argument)
(define-key minibuffer-local-completion-map [remap digit-argument]
  'icicle-digit-argument)

